# -*- encoding: utf-8 -*-
##############################################################################
#
#    Copyright (c) 2011 Ting & Avanzosc (http://www.openerpsite.com) All Rights Reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see http://www.gnu.org/licenses/.
#
##############################################################################

from osv import osv, fields
import tools
import math
from tools.translate import _
import time
from datetime import datetime

class account_analytic_account(osv.osv):
    _name = "account.analytic.account"
    _inherit = "account.analytic.account"
    
#    def _acc_result(cr,uid,ids):
#        dif_acc = self.browse(cr,uid,ids)
#        dif = dif_acc.debit - dif_acc.total_estimated
#        return dif
    
    _columns = {
                'total_estimated':fields.float('Estimated'),
                'acc_type':fields.char('Account type',size = 2),
                'acc_result':fields.float('Account result')
                }
    
    def recalculate_result(self, cr, uid, acc_id):
        analytic_obj = self.pool.get('account.analytic.account')
        if acc_id:
            acc = analytic_obj.browse(cr, uid, acc_id)
            
            resu = float(acc.balance) + float(acc.total_estimated)
            
            analytic_obj.write(cr, uid, acc_id,{'acc_result':resu})
            
            if not acc.acc_type == 'MF':            
                self.recalculate_result(cr, uid, acc.parent_id.id)
        return True
    
    def calculate_estimated(self, cr, uid, parnt_id, amount):
        
        analytic_obj = self.pool.get('account.analytic.account')
        acc = analytic_obj.browse(cr, uid, parnt_id)
        
        total = acc.total_estimated
        if total is None:
            total = 0.0
        tot = total + amount
        resu = acc.debit - tot
        analytic_obj.write(cr,uid,parnt_id,{'total_estimated':tot,'acc_result':resu})
        if not acc.acc_type == 'MF':            
            self.calculate_estimated(cr, uid, acc.parent_id.id, amount)
        
        return True
    
    _defaults = {
        'total_estimated': 0.00,    
                }
account_analytic_account()


class mrp_production_operation_real(osv.osv):

    _inherit = "mrp.production.operation.real"
    _name = "mrp.production.operation.real"
    
    def action_done(self, cr, uid, ids):
        
        """ Sets state to done, writes finish date and calculates delay.
        @return: True
        """
        tot_time = 0.0
        date_now = time.strftime('%Y-%m-%d %H:%M:%S')
        obj_line = self.browse(cr, uid, ids[0])
        
        if not obj_line.move_lines2:   
            raise osv.except_osv(_('Error'), _('You can not finish before produce'))
        
        date_start = datetime.strptime(obj_line.date_start,'%Y-%m-%d %H:%M:%S')
        
        date_finished = datetime.strptime(date_now,'%Y-%m-%d %H:%M:%S')
        tot_time += (date_finished-date_start).days * 24
        tot_time += (date_finished-date_start).seconds / float(60*60)
        
        tot_time -=     obj_line.paused_time       
        
        if obj_line.date_restart:
                date_start = datetime.strptime(obj_line.date_restart,'%Y-%m-%d %H:%M:%S')
        
        delay = 0.0
        
        date_finished = datetime.strptime(date_now,'%Y-%m-%d %H:%M:%S')
        delay += (date_finished-date_start).days * 24
        delay += (date_finished-date_start).seconds / float(60*60)              
            
            
        time_obj = self.pool.get('new.input.time')           
        
        time_obj.input_real_worktime(cr, uid, ids, uid, delay, obj_line.mrp_manu_op.id, date_now, 'Work in '+str(obj_line.workcenter_id.name))
        
        self.write(cr, uid, ids, {'state':'done', 'date_finished': date_now,'delay':tot_time})
        self.modify_production_order_state(cr,uid,ids,'done')
        
                #Añadido link a contabilidad analitica para costes de materiales
        
        self.pool.get('ana.wiz').mats_final_cost(cr, uid, ids[0])
        
        return True
    
mrp_production_operation_real()
#class mrp_production_operation_real(osv.osv):
#    _name = 'mrp.production.operation.real'
#    _inherit = 'mrp.production.operation.real'
#    
#    def action_done(self, cr, uid, ids):
#        
#    
#mrp_production_real()